#pragma once

#include "Array.h"
#include "Critical.h"

namespace Framework
{
    struct DLLDatei
    {
        Text *name;
        HINSTANCE handle;
        int ref;
    };

    class DLLRegister
    {
    private:
        Array< DLLDatei * > *dlls;
        Critical cs;
        int ref;

    public:
        //! Konstruktor
        __declspec(dllexport) DLLRegister();
        //! Destruktor
        DLLEXPORT ~DLLRegister();
        //! nicht constant       
        DLLEXPORT HINSTANCE ladeDLL( char *name, char *pfad );
        DLLEXPORT void releaseDLL( char *name );
        //! Reference Counting   
        DLLEXPORT DLLRegister *getThis();
        DLLEXPORT DLLRegister *release();
    };
}